select distinct
    an.numero
    , m.data
    , 'AD' as teto

from
    mamite m
    join animal an on an.cdanimal = m.cdanimal
    left join mamite m2 on m2.cdmamite =
        (select first 1 re.cdmamite from mamite re where re.cdanimal = m.cdanimal and re.cdmamite <> m.cdmamite and re.data < m.data and re.ad in (0,1,2) order by re.data desc)

where
    m.ad in (0,1,2)
    and ((m2.cdmamite is null) or ((m2.cdmamite is not null) and ((m.data - m2.data) > 14)))

union

select distinct
    an.numero
    , m.data
    , 'AE' as teto

from
    mamite m
    join animal an on an.cdanimal = m.cdanimal
    left join mamite m2 on m2.cdmamite =
        (select first 1 re.cdmamite from mamite re where re.cdanimal = m.cdanimal and re.cdmamite <> m.cdmamite and re.data < m.data and re.ae in (0,1,2) order by re.data desc)

where
    m.ae in (0,1,2)
    and ((m2.cdmamite is null) or ((m2.cdmamite is not null) and ((m.data - m2.data) > 14)))

union

select distinct
    an.numero
    , m.data
    , 'PD' as teto

from
    mamite m
    join animal an on an.cdanimal = m.cdanimal
    left join mamite m2 on m2.cdmamite =
        (select first 1 re.cdmamite from mamite re where re.cdanimal = m.cdanimal and re.cdmamite <> m.cdmamite and re.data < m.data and re.pd in (0,1,2) order by re.data desc)

where
    m.pd in (0,1,2)
    and ((m2.cdmamite is null) or ((m2.cdmamite is not null) and ((m.data - m2.data) > 14)))

union

select distinct
    an.numero
    , m.data
    , 'PE' as teto

from
    mamite m
    join animal an on an.cdanimal = m.cdanimal
    left join mamite m2 on m2.cdmamite =
        (select first 1 re.cdmamite from mamite re where re.cdanimal = m.cdanimal and re.cdmamite <> m.cdmamite and re.data < m.data and re.pe in (0,1,2) order by re.data desc)

where
    m.pe in (0,1,2)
    and ((m2.cdmamite is null) or ((m2.cdmamite is not null) and ((m.data - m2.data) > 14)))

order by 1, 2
